unit Gerichte_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Grids, Types;

type

  { TForm1 }

  TForm1 = class(TForm)
    gridGericht: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure gridGerichtHeaderClick(Sender: TObject; IsColumn: Boolean;
      Index: Integer);
    procedure gridGerichtMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure gridGerichtPrepareCanvas(sender: TObject; aCol, aRow: Integer;
      aState: TGridDrawState);
  private
    procedure SpaltenAnpassen;
    procedure GerichteLaden;
  public

  end;

var
  Form1: TForm1;

const
  Pfeil='  >';
  leer='';
  Gerichteliste='Meine_Gerichte_heute.txt';
  trenner='. ';
  clPfeilAktiv=clSilver;
  clPfeilInaktiv=clGray;

implementation

{$R *.lfm}

{ TForm1 }

function GetContrastTextColor(const BackColor: TColor): TColor;
begin                                              {Textfaebe abh. vom Hintergrund}
  if (Red(BackColor) * 0.25+
      Green(BackColor) * 0.625+
      Blue(BackColor) * 0.125) > 90 then
    result := clBlack
  else
    result := clWhite;
end;

procedure CellColorSetting(aGrid: TStringGrid; Farbe: TColor); {Zellen einfärben}
begin
  aGrid.Canvas.Brush.Color:=Farbe;
  aGrid.Canvas.Font.Color:=GetContrastTextColor(Farbe);
end;

procedure TForm1.GerichteLaden;
var
  fn: string;
  glist: TStringlist;
  i: integer;

begin
  fn:=Application.Location+Gerichteliste;
  if FileExists(fn) then begin
    glist:=TStringList.Create;
    gridGericht.RowCount:=1;
    try
      glist.LoadFromFile(fn);
      for i:=0 to glist.Count-1 do begin
        if pos(trenner, glist[i])>1 then begin
          gridGericht.RowCount:=gridGericht.RowCount+1;
          gridGericht.Cells[0, gridGericht.RowCount-1]:=glist[i].Split([trenner])[0];
          gridGericht.Cells[1, gridGericht.RowCount-1]:=glist[i].Split([trenner])[1];
          gridGericht.Cells[2, gridGericht.RowCount-1]:=Pfeil;
          gridGericht.Cells[3, gridGericht.RowCount-1]:=leer;
          gridGericht.Cells[4, gridGericht.RowCount-1]:=leer;
        end;
      end;
    finally
      glist.Free;
    end;
  end;
end;

procedure TForm1.SpaltenAnpassen;
begin
  gridGericht.ColWidths[0]:=60;
  gridGericht.ColWidths[3]:=60;
  gridGericht.ColWidths[0]:=80;
  gridGericht.ColWidths[1]:=(gridGericht.Width-210) div 2;
  gridGericht.ColWidths[4]:=gridGericht.ColWidths[1];
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: integer;

begin
  SpaltenAnpassen;
  gridGericht.TitleFont.Height:=40;
  gridGericht.Font.Height:=30;
  gridGericht.Cells[0, 0]:='Nr';
  gridGericht.Cells[1, 0]:='Gericht in Arbeit';
  gridGericht.Cells[2, 0]:=Pfeil;
  gridGericht.Cells[3, 0]:='Nr';
  gridGericht.Cells[4, 0]:='Gericht fertig';
  for i:=1 to gridGericht.RowCount-1 do begin
    gridGericht.Cells[0, i]:=IntToStr(i);
    gridGericht.Cells[2, i]:=Pfeil;
  end;
  GerichteLaden;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  SpaltenAnpassen;
end;

procedure TForm1.gridGerichtHeaderClick(Sender: TObject; IsColumn: Boolean;
  Index: Integer);
begin
  GerichteLaden;
end;

procedure TForm1.gridGerichtMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  sp, zl: integer;
begin
  gridGericht.MouseToCell(x, y, sp, zl);
  if (zl>0) and (sp<3) and (gridGericht.Cells[0, zl]<>leer) then begin
    gridgericht.BeginUpdate;
    gridGericht.Cells[3, zl]:=gridGericht.Cells[0, zl];
    gridGericht.Cells[4, zl]:=gridGericht.Cells[1, zl];
    gridGericht.Cells[0, zl]:=leer;
    gridGericht.Cells[1, zl]:=leer;
    gridGericht.EndUpdate;
  end;
end;

procedure TForm1.gridGerichtPrepareCanvas(sender: TObject; aCol, aRow: Integer;
  aState: TGridDrawState);
begin
  if aRow>0 then begin
    case aCol of
      0, 1:CellColorSetting(gridGericht, clRed);
      2:   if gridGericht.Cells[1, aRow]=leer then
             CellColorSetting(gridGericht, clPfeilInaktiv)
           else
             CellColorSetting(gridGericht, clPfeilAktiv);
      3, 4:CellColorSetting(gridGericht, clGreen);
    end;
  end;
end;

end.

